﻿using C1.Win.C1FlexGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MultiColumnORFilter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            _flex.Cols.Count = 6;

            // Set Column Captions
            for (int col = _flex.Cols.Fixed; col < 6; ++col)
            {
                _flex.Cols[col].Caption = $"Column #{col}";
            }

            // Fill random values
            Random random = new Random();
            for (int i = _flex.Rows.Fixed; i < _flex.Rows.Count; ++i)
            {
                for (int j = _flex.Cols.Fixed; j < 6; ++j)
                {
                    _flex[i, j] = random.Next(1, 100);
                }
            }

            btnApplyFilter.Click += BtnApplyFilter_Click;
            btnReset.Click += BtnReset_Click;
        }

        private void BtnApplyFilter_Click(object sender, EventArgs e)
        {
            List<int> filterColIndices = new List<int>();
            if (chkColumn1.Checked)
                filterColIndices.Add(1);
            if (chkColumn2.Checked)
                filterColIndices.Add(2);
            if (chkColumn3.Checked)
                filterColIndices.Add(3);
            if (chkColumn4.Checked)
                filterColIndices.Add(4);
            if (chkColumn5.Checked)
                filterColIndices.Add(5);

            if (filterColIndices.Count == 0)
                return;

            int parameter = Convert.ToInt32(numericUpDown.Value);

            for (int row = _flex.Rows.Fixed; row < _flex.Rows.Count; ++row)
            {
                bool rowVisibility = false;
                foreach (int col in filterColIndices)
                {
                    if (Convert.ToInt32(_flex[row, col]) > parameter)
                    {
                        rowVisibility = true;
                        break;
                    }
                }
                _flex.Rows[row].Visible = rowVisibility;
            }
        }

        private void BtnReset_Click(object sender, EventArgs e)
        {
            for (int row = _flex.Rows.Fixed; row < _flex.Rows.Count; ++row)
            {
                _flex.Rows[row].Visible = true;
            }
        }
    }
}
